#ifndef ALMAINWINDOW_H
#define ALMAINWINDOW_H

#include "ui_ALMainWindow.h"
#include "world.h"
#include "worldengine.h"
#include "alcontactlistener.h"
#include <QTimer>
#include <QFile>

class ALMainWindow : public QMainWindow, Ui::ALMainWindow
{
   Q_OBJECT
   
   public:
      ALMainWindow( QWidget *parent = 0 );
      virtual ~ALMainWindow();
      
   public slots:
      void on_createWorldButton_clicked();
      void on_clearInhabitantsButton_clicked();
      
      void on_createPlantsButton_clicked();
      void on_createHerbivoresButton_clicked();
      void on_createPredatorsButton_clicked();
      
      void on_animateButton_clicked();
      void on_diaplayWorldCheckBox_toggled(bool checked);
      void on_resetTimeButton_clicked();
      
      void on_browseStatisticsFileButton_clicked();
      void on_openStatisticsFileButton_clicked();
      
      void on_action_Save_triggered();
      
      void updateStatistics();
   
    private:
        World *m_world; // the original that gets passed down
        QMutex *m_worldMutex; // the original that gets passed down
        
        WorldEngine *m_worldEngine;
        
        ALContactListener m_contactListener;
	
	QFile m_statisticsFile;
	
	QTimer m_statisticsUpdateTimer;
	double m_worldTime;
        
        void loadWindowState();
        void saveWindowState();
};

#endif // ALMAINWINDOW_H
