#include "ANN.h"
#include <random>
#include <math.h>

ANN::ANN(vector<int> lay,bool initial){
	layout = lay;
	for (int i = 0; i < layout.size() - 1; i++){
		//neuroni u layeru
		vector<vector<float>> layer(layout[i+1]);
		//za svaki neuron
		for (int j = 0; j < layout[i+1]; j++){
			for (int k = 0; k < layout[i]; k++){
				if (initial)
				layer[j].push_back(randomize_uniform());
				else layer[j].push_back(0.0f);
			}
			
		}
		weights.push_back(layer);
	}
}

float ANN::getOutput(vector<float>& in){
	if (in.size() != layout[0]){
		throw 7;
	}

	vector<float> inputs = in;
	//po layerima
	for (int i = 0; i < layout.size()-1; i++){
		//vrijednost outputa neurona
		vector<float> inter(layout[i + 1]);
		
		//po neuronima
		for (int j = 0; j < layout[i + 1]; j++){
			// po ulazima neurona
			for (int k = 0; k < layout[i]; k++){
				inter[j] += weights[i][j][k] * inputs[k];
			}
			inter[j] = 1.0f/(1-exp2f(inter[j]));
		}
		inputs = inter;
	}
	float ret = 0.0f;
	for (float t : inputs){
		ret += t;
	}
	ret = 1.0f / (1 - exp2f(ret));
	return ret;
}


float ANN::randomize_uniform(){
	std::random_device rd;
	std::mt19937 gen(rd());
	std::uniform_real_distribution<float> dis(min, max);
	return  dis(gen);
}

float ANN::randomize_gauss(){
	std::random_device rd;
	std::mt19937 gen(rd());
	std::normal_distribution<float> distribution(mean, deviation);
	return  distribution(gen);
}