#include "MatrixANN.h"
#include <random>


template <class T> MatrixANN<T>::MatrixANN(int width, int heigth) {
	mat = new T[width*heigth];
	this->width = width;
	this->heigth = heigth;
}

template <class T> MatrixANN<T>::~MatrixANN(void){
	delete[] mat;
}

template <class T> T* MatrixANN<T>::operator[] (int k) {
	return mat + this.width*k;
}

template <class T> void MatrixANN<T>::randomize_gauss(){
	std::random_device rd;
	std::mt19937 gen(rd());
	std::normal_distribution<T> distribution(mean, deviation);

	for (int i = 0; i < width*heigth; i++)
	{
		mat[i] = distribution(gen);
	}
}

template <class T> void MatrixANN<T>::randomize_uniform(){
	std::random_device rd;
	std::mt19937 gen(rd());
	std::uniform_real_distribution<> dis(min, max);
	for (int i = 0; i < width*heigth; i++)
	{
		mat[i] = dis(gen);
	}
};

template <class T> MatrixANN<T> MatrixANN<T>::operator* (MatrixANN<T> multi) {
	if (heigth != multi.width)
	{
		throw 7;
	}
	MatrixANN<int> ret(width, multi.heigth);
	for (int i = 0; i < ret.width; i++)
	{
		for (int j = 0; j < ret.heigth; j++)
		{
			for (int k = 0; k < heigth; k++)
			{
				ret[i][j] = (this->operator[](i))[k] * multi[k][j];
			}
		}
	}
}