#ifndef UTIL_H
#define UTIL_H
#include <cmath>

const float M_PI = 3.14f;

#define DEGTORAD(a)     (a*M_PI/180.0)
#define RADTODEG(a)     (a*180.0/M_PI)

#include <QObject>
#include <Box2D/Box2D.h>

class Util : public QObject
{
    Q_OBJECT
    
public:
    static double mutate( double initialValue, double randomization )
    {
	int sign = qrand() / (float) RAND_MAX > 0.5 ? -1 : 1;
	double num = qrand() / (float) RAND_MAX * randomization;
	return initialValue + (sign * num);
    }
    
    static b2Vec2 mutate( b2Vec2 initialValue, double randomization )
    {
	b2Vec2 retVal;
	retVal.x = mutate(initialValue.x, randomization);
	retVal.y = mutate(initialValue.y, randomization);
	return retVal;
    }
    
    static double distance( b2Vec2 point1, b2Vec2 point2 )
    {
	double width = point1.x - point2.x;
	double height = point1.y - point2.y;
	
	//removed sqrt,distance req just for comparisons
	return width*width + height*height;
    }
    
protected:
    
};

#endif
 
