#ifndef WORLD_H
#define WORLD_H

#include <stdlib.h>
#include <QObject>
#include "creature.h"
#include "plant.h"
#include "herbivore.h"
#include "predator.h"
#include "PredatorANN.h"

using namespace std;

class b2World;

class World : public QObject
{
    Q_OBJECT
    
public:
    World(QObject *parent = 0);
    ~World();
    
    /**
     * width height
     * type
     * position
     */
    void save( QString filename );
    Plant* addPlant(const CreatureConfiguration &configuration);
    Plant* addPlant(const b2Vec2& pos, float size);
    Herbivore* addHerbivore(const CreatureConfiguration &configuration);
    Herbivore* addHerbivore(const b2Vec2& pos, float size);
    Predator* addPredator(const CreatureConfiguration &configuration);
    Predator* addPredator(const b2Vec2& pos, float size);
    void addCreature(Creature *creature);
    
    void clearInhabitants();
    
    void createBorder(const b2Vec2& size);
    
    void Step(float timeStep, int velocityIterations, int positionIterations);
    void SetContactListener(b2ContactListener* contactListener);
    
    const QList<Creature*>& population();
    
	//should be dynamic
	int wh = 10;

    const QList<b2Body*>& border();
    b2Vec2 size();
	vector<vector<vector<Creature *>>> grid;
    

    b2World *m_box2DWorld;
    QList<Creature*> m_population;
    
    QList<b2Body*> m_border;
    b2Vec2 m_size;
};

#endif
